package Hooke;

public class Spring extends PhysicsElement  {
   private static int id=0;  // Spring identification
   private float restLength;
   private final float stiffness;
   private Block block1;
   private Block block2;

   private Spring(){  // nobody can create a block without state
     super(id++);
     stiffness=0;
   }
   public Spring(float restLength, float stiffness){
     super(id++);
     this.restLength = restLength;
     this.stiffness = stiffness;
   }
   public Spring(float restLength, float stiffness, Block block1, Block block2){
     this(restLength, stiffness);
     this.block1=block1;
     this.block2=block2;
   }
   public void attachLeftBlock(Block block){
       attachBlock(block);
   }
   public void attachRigthBlock(Block block){
       attachBlock(block);
   }
   public void attachBlock (Block block) {
     if(block1 == null) block1=block;
     else if(block2 == null) block2=block;
     else System.out.println("El resorte ya tiene dos bloques");
   }
   public double getLength() {
     if (block1 == null || block2 == null) return restLength;
      return (Vector2D.distanciaVectores(block1.getPosition(), block2.getPosition()));
   }

   public Vector2D getForce(Block block) {
   Vector2D force= null;
     if (block == block1 && block2 != null) { //Se representa el resorte como un vector de modulo restlength
         force = new Vector2D (restLength,Vector2D.getAngulo(block1.getPosition(), block2.getPosition()));
                            //Se obtiene la distancia entre los dos bloques, en forma de vector
         Vector2D delta_pos = Vector2D.restarVectores(block1.getPosition(),block2.getPosition());
                            //Se obtiene la fuerza
         force.restarVector(delta_pos);//block1.getPosition());
     }else
     if (block == block2 && block1 != null) {
         force = new Vector2D (restLength,Vector2D.getAngulo(block2.getPosition(), block1.getPosition()));
         Vector2D delta_pos = Vector2D.restarVectores(block2.getPosition(),block1.getPosition());
         force.restarVector(delta_pos);//block2.getPosition());
     }else {
       force = new Vector2D(0,0);
     }
     force.multiplicaEscalar(this.stiffness);
     return force;
   }
   public void computeNextState(double delta_t) {
   }
   public void updateState(){
   }
   public String getDescription() {
      return "Spring_"+ getId()+": x0,y0,x1,y1";
   }
   public String getState() {
      String s;
      if (block1 != null)
         s = block1.getPosition()+",";
      else if (block2 != null)
              s = Vector2D.sumarRadio(block2.getPosition(), -restLength)+",";//(block2.getPosition()-restLength)+",";
            else  
              s = "0,";  // up to here left end is determined 
      if (block2 != null)
         s += block2.getPosition();
      else if (block1 != null)
               s += Vector2D.sumarRadio(block1.getPosition(), restLength);
            else
               s += "0"; 
      return s;
   }
}
          
    
    
           
      